/*!******************************************************************
*  File: mbsrout.h 
*  ===============   
* 
*  Definitions for the MBS interpreter.
*
*  This file is part of the Program Module Library. 
* 
*  URL:  http://www.varkon.com 
*    
*  This library is free software; you can redistribute it and/or 
*  modify it under the terms of the GNU Library General Public 
*  License as published by the Free Software Foundation; either 
*  version 2 of the License, or (at your option) any later 
*  version. 
* 
*  This library is distributed in the hope that it will be 
*  useful, but WITHOUT ANY WARRANTY; without even the implied  
*  warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR 
*  PURPOSE.  See the GNU Library General Public License for more  
*  details.   
*   
*  You should have received a copy of the GNU Library General 
*  Public License along with this library; if not, write to the 
*  Free Software Foundation, Inc., 675 Mass Ave, Cambridge, 
*  MA 02139, USA. 
*       
*  (C)Microform AB 1984-1999, J.Kjellander,  johan@microform.se
*   
*********************************************************************
*      Routine-ID's for MBS functions and procedures.
********************************************************************/

#define VPOI     1    /*      POI_FREE    */
#define VPOIP    2    /*      POI_PROJ    */
#define VLINF    3    /*      LIN_FREE    */
#define VLINP    4    /*      LIN_PROJ    */
#define VLINA    5    /*      LIN_ANG     */
#define VLINO    6    /*      LIN_OFS     */
#define VLINT1   7    /*      LIN_TAN1    */
#define VLINT2   8    /*      LIN_TAN2    */
#define VARCF    9    /*      ARC_FREE    */
#define VARC2P  10    /*      ARC_2POS    */
#define VARC3P  11    /*      ARC_3POS    */
#define VARCO   12    /*      ARC_OFS     */
#define VARCFI  13    /*      ARC_FIL     */
#define VCURF   14    /*      CUR_FREE   Utgr ! */
#define VCURP   15    /*      CUR_PROJ   Utgr ! */
#define VCURO   16    /*      CUR_OFFS    */
#define VCOMP   17    /*      COMP        */
#define VXHT    18    /*      XHATCH      */
#define VPART   19    /*      PART        */
#define VIONSUR 20    /*      INV_ON_SUR  */
#define VTEXT   21    /*      TEXT        */
#define VPLANE  22    /*      *****      Ledig   */
#define VCSYS3P 23    /*      CSYS_3P     */
#define VGROUP  24    /*      GROUP       */
#define VLDIM   25    /*      LDIM        */
#define VCDIM   26    /*      CDIM        */
#define VRDIM   27    /*      RDIM        */
#define VADIM   28    /*      ADIM        */

#define VACOS   29    /*      ARCSIN      */
#define VASIN   30    /*      ARCSIN      */
#define VATAN   31    /*      ARCTAN      */
#define VCOS    32    /*      COS         */
#define VSIN    33    /*      SIN         */
#define VTAN    34    /*      TAN         */
#define VLN     35    /*      LN          */
#define VLOG    36    /*      LOG         */
#define VSQRT   37    /*      SQRT        */
#define VABS    38    /*      ABS         */
#define VFRAC   39    /*      FRAC        */
#define VROUND  40    /*      ROUND       */
#define VTRUNC  41    /*      TRUNC       */

/*
***Nya rutiner i samband med Kartro 30/5/86
*/

#define VGTREF  42    /*      GETREF      */
#define VLDGM   43    /*      LOAD_GM     */
#define VSVGM   44    /*      SAVE_GM     */
#define VBLEV   45    /*      BLANK_LEV   */
#define VUBLEV  46    /*      UNBLANK_LEV */
#define VGTLEV  47    /*      GET_LEV     */
#define VACLEV  48    /*      ACT_LEV     */
#define VNCURI  49    /*      N_CUR_INT   */
#define VEVAL   50    /*      EVAL        */

/*
***Ny rutin fr version 1.4  9/4/87 
*/

#define VFINDS  51    /*      FINDS       */

#define VARCL   52    /*      ARCL        */
#define VTANG   53    /*      TANG        */
#define VCENTRE 54    /*      CENTRE      */
#define VINTERS 55    /*      INTERSECT   */
#define VON     56    /*      ON          */
#define VVECP   57    /*      VECP        */
#define VIDENT  58    /*      IDENT       */
#define VPOS    59    /*      POS         */
#define VSCREEN 60    /*      SCREEN      */
#define VBPLAN  61    /*      B_PLANE     */

#define V2MOD   62    /*      D2MOD       */
#define VMODLO  62    /*      MODE_LOCAL  */
#define V3MOD   63    /*      D3MOD       */
#define VMODGL  63    /*      MODE_GLOBAL */
#define VVEC    64    /*      VEC         */
#define VSET    65    /*      SET         */
#define VOS     66    /*      OS          */

/*
***Nya rutiner fr version 1.4  9/4/87
*/

#define VVECL   67    /*      VECL        */
#define VVECN   68    /*      VECN        */
#define VANGLE  69    /*      ANGLE       */

#define VASCII  70    /*      ASCII       */
#define VSTR    71    /*      STR         */
#define VCHR    72    /*      CHR         */
#define VVAL    73    /*      VAL         */
#define VLENGTH 74    /*      LENGTH      */
#define VSUBSTR 75    /*      SUBSTR      */

#define VOPEN   76    /*      OPEN        */
#define VSEEK   77    /*      SEEK        */
#define VOUTINT 78    /*      OUTINT      */
#define VOUTFLT 79    /*      OUTFLT      */
#define VOUTSTR 80    /*      OUTSTR      */
#define VOUTLIN 81    /*      OUTLIN      */
#define VOUTBIN 82    /*      OUTBIN      */
#define VININT  83    /*      ININT       */
#define VINFLT  84    /*      INFLT       */
#define VINSTR  85    /*      INSTR       */
#define VINLIN  86    /*      INLIN       */
#define VINBIN  87    /*      INBIN       */
#define VFPOS   88    /*      FPOS        */
#define VCLOSE  89    /*      CLOSE       */
#define VIOSTAT 90    /*      IOSTAT      */

/*
***Nya rutiner i och med version 1.2, 13/3/86.
*/

#define VGTID   91    /*      GETID      Utgr */
#define VGTHDR  92    /*      GETHDR      */
#define VGTPOI  93    /*      GETPOI      */
#define VGTLIN  94    /*      GETLIN      */
#define VGTARC  95    /*      GETARC      */
#define VGTCUR  96    /*      GETCUR     Utgr */
#define VGTTRF  97    /*      GETTRF      */
#define VGTTXT  98    /*      GETTXT      */
#define VGTXHT  99    /*      GETXHT      */
#define VGTLDM 100    /*      GETLDM      */
#define VGTCDM 101    /*      GETCDM      */
#define VGTRDM 102    /*      GETRDM      */
#define VGTADM 103    /*      GETADM      */
#define VGTGRP 104    /*      GETGRP      */
#define VGTCSY 105    /*      GETCSY      */
#define VGTSYM 106    /*      GETSYM     Utgr */
#define VGTPRT 107    /*      GETPRT      */
#define VGTTYP 108    /*      GETTYP      */
#define VGTINT 109    /*      GETINT      */
#define VGTFLT 110    /*      GETFLT      */
#define VGTSTR 111    /*      GETSTR      */
#define VGTVEC 112    /*      GETVEC      */

#define VSYMB  113    /*      SYMB        */
#define VTRIM  114    /*      TRIM        */
#define VDEL   115    /*      DEL         */
#define VCLGM  116    /*      CLEAR_GM    */
#define VBLNK  117    /*      BLANK      Utgr */
#define VUBLNK 118    /*      UNBLANK    Utgr */

/* Nya rutiner fr Kartro 30/6/86         */

#define VCREVI 119    /*      CRE_VIEW    */
#define VACTVI 120    /*      ACT_VIEW    */
#define VSCLVI 121    /*      SCL_VIEW    */
#define VCENVI 122    /*      CEN_VIEW    */
#define VERAVI 123    /*      ERASE_VIEW  */
#define VREPVI 124    /*      REP_VIEW    */
#define VCACVI 125    /*      CACC_VIEW   */

/* Ny rutin fr version 1.3 3/11/86     */

#define VPLTVI  126    /*      PLOT_VIEW   */

/* Nya rutiner fr version 1.3 1/10/86    */

#define VTIM    127    /*      TIME        */
#define VRSTR   128    /*      RSTR        */
#define VRVAL   129    /*      RVAL        */
#define VREFC   130    /*      REFC        */
#define VLSIN   131    /*      LST_INI     */
#define VLSEX   132    /*      LST_EXI     */
#define VLSLN   133    /*      LST_LIN     */

/* Nya rutiner fr version 1.3 30/10/86    */

#define VACBLK  134    /*      ACT_BLANK   */
#define VACVIN  135    /*      ACT_VNAM    */
#define VACPEN  136    /*      ACT_PEN     */
#define VACSCL  137    /*      ACT_SCL     */
#define VACDSCL 138    /*      ACT_DSCL    */
#define VACCAC  139    /*      ACT_CACC    */
#define VACGRX  140    /*      ACT_GRIDX   */
#define VACGRY  141    /*      ACT_GRIDY   */
#define VACGRDX 142    /*      ACT_GRIDDX  */
#define VACGRDY 143    /*      ACT_GRIDDY  */
#define VACGRID 144    /*      ACT_GRID    */

#define VACJOBN 145    /*      ACT_JOBNAM  */
#define VACMTYP 146    /*      ACT_MTYPE   */
#define VACMATR 147    /*      ACT_MATTR   */
#define VACJOBD 148    /*      ACT_JOBDIR  */

#define VACLFNT 149    /*      ACT_LFONT   */
#define VACAFNT 150    /*      ACT_AFONT   */
#define VACXFNT 151    /*      ACT_XFONT   */
#define VACLDSL 152    /*      ACT_LDASHL  */
#define VACADSL 153    /*      ACT_ADASHL  */
#define VACXDSL 154    /*      ACT_XDASHL  */
#define VACTSIZ 155    /*      ACT_TSIZE   */
#define VACTWID 156    /*      ACT_TWIDTH  */
#define VACTSLT 157    /*      ACT_TSLANT  */
#define VACDTSZ 158    /*      ACT_DTSIZ   */
#define VACDASZ 159    /*      ACT_DASIZ   */
#define VACDNDG 160    /*      ACT_DNDIG   */
#define VACDAUT 161    /*      ACT_DAUTO   */

/* Ny rutin fr version 1.4 21/12/86       */

#define VGLOREF 162    /*      GLOBAL_REF  */

/* Nya rutiner fr version 1.4 April 87    */

#define VPSPMT  163    /*      PSH_PMT     */
#define VPOPMT  164    /*      POP_PMT     */
#define VCRTSTR 165    /*      CRE_TSTR    */
#define VGTTSTR 166    /*      GET_TSTR    */
#define VCRMEN  167    /*      CRE_MEN     */
#define VPSMEN  168    /*      PSH_MEN     */
#define VPOMEN  169    /*      POP_MEN     */
#define VGTALT  170    /*      GET_ALT     */
#define VGTMEN  171    /*      GET_MEN     */
#define VVPROD  172    /*      VPROD       */
#define VLINPER 173    /*      LIN_PERP    */

/* Nya rutiner fr databaskommunikation Maj 87 */

#define VDBOP   174    /*      DB_OPEN     */
#define VDBBG   175    /*      DB_BEGIN    */
#define VDBSL   176    /*      DB_SELECT   */
#define VDBUP   177    /*      DB_UPDATE   */
#define VDBIN   178    /*      DB_INSERT   */
#define VDBDL   179    /*      DB_DELETE   */
#define VDBEN   180    /*      DB_END      */
#define VDBRL   181    /*      DB_ROLLBACK */
#define VDBCL   182    /*      DB_CLOSE    */
#define VDBFI   183    /*      DB_FETCHI   */
#define VDBFF   184    /*      DB_FETCHF   */
#define VDBFS   185    /*      DB_FETCHS   */
#define VDBNX   186    /*      DB_NEXT     */

/* Nya rutiner fr V 1.5 */

#define VGTBPL  187    /*      GETBPL      */
#define VCSYS1P 188    /*      CSYS_1P     */

/* Nya rutiner fr V 1.6 */

#define VPLTWI  189    /*      PLOT_WIN    */

/* Nya rutiner fr V1.7 Oktober 1988 */

#define VUPHDR  190    /*      UPDHDR      */
#define VLDJOB  191    /*      LOAD_JOB    */
#define VSVJOB  192    /*      SAVE_JOB    */
#define VINPMT  193    /*      INPMT       */

/* Nya rutiner fr V1.8 Mars 1989 */

#define VHIDVI  194    /*      HIDE_VIEW   */
#define VPRPVI  195    /*      PERP_VIEW   */
#define VTEXTL  196    /*      TEXTL       */
#define VEXIT   197    /*      EXIT        */
/*
***Nya rutiner fr V1.10 Juli 1990.
*/
#define VEXEST  198    /*      EXESTAT     */
#define VAREA   199    /*      AREA        */
#define VCGRAV  200    /*      CGRAV       */
#define VSETB   201    /*      SET_BASIC   */
/*
***Nya rutiner fr V1.11 1991.
*/
#define VCURC   202    /*      CUR_CONIC   */
#define VITANG  203    /*      INV_TANG    */
#define VCURS   204    /*      CUR_SPLINE  */
#define VION    205    /*      INV_ON      */
#define VCURT   206    /*      CUR_TRIM    */
#define VCURU   207    /*      CUR_USRDEF  */
#define VCURV   208    /*      CURV        */
#define VICURV  209    /*      INV_CURV    */
#define VIARCL  210    /*      INV_ARCL    */
#define VACCFNT 211    /*      ACT_CFONT   */
#define VACCDSL 212    /*      ACT_CDASHL  */
#define VADDMBS 213    /*      ADD_MBS     */
#define VNINTER 214    /*      N_INTERSECT */
#define VGPMBS  215    /*      GETP_MBS    */
#define VUPMBS  216    /*      UPDP_MBS    */
/*
***Nya rutiner fr ytmodulen 10/7/92 
*/
#define VSUREX  217    /*      SUR_EXDEF   */
#define VCURSIL 218    /*      CUR_SIL     */
#define VCURINT 219    /*      CUR_INT     */
#define VCURISO 220    /*      CUR_ISO     */
#define VNORM   221    /*      NORM        */
/*
***Nya rutiner fr transformationer 10/12/92
*/
#define VTFMOV  222    /*      TFORM_MOVE   */
#define VTFROTP 223    /*      TFORM_ROTP   */
#define VTFROTL 224    /*      TFORM_ROTL   */
#define VTFMIRR 225    /*      TFORM_MIRR   */
#define VTFCOMP 226    /*      TFORM_COMP   */
#define VTFU    227    /*      TFORM_USRDEF */
#define VTCOPY  228    /*      TCOPY        */
/*
***Ny rutin fr GL 17/2/93
*/
#define VCURGL  229    /*      CUR_GL       */
/*
***Ny rutin fr SAAB 8/8/93
*/
#define VMSIZE  230    /*      MSIZE_VIEW   */
/*
***Nya rutiner fr fnsterhantering 6/12/93
*/
#define VCRWIN  231    /*      CRE_WIN    */
#define VCREDI  232    /*      CRE_EDIT   */
#define VCRICO  233    /*      CRE_ICON   */
#define VCRBUT  234    /*      CRE_BUTTON */
#define VSHWIN  235    /*      SHOW_WIN   */
#define VWTWIN  236    /*      WAIT_WIN   */
#define VGTEDI  237    /*      GET_EDIT   */
#define VGTICO  238    /*      GET_ICON  Anvnds ej */
#define VGTBUT  239    /*      GET_BUTTON */
#define VDLWIN  240    /*      DEL_WIN    */
/*
***Nya GM-get rutiner fr kurvor och ytor. 10/1/94
*/
#define VGTCUH  241    /*      GETCURH    */
#define VGTSEG  242    /*      GETSEG     */
#define VGTSUH  243    /*      GETSURH    */
/*
***Nya Macro-rutiner 2/2/94.
*/
#define VUPPMBS 244    /*      UPDPP_MBS  */
/*
***Nya Ytmodul-rutiner 25/4/94.
*/
#define VSURCON 245    /*      SUR_CONIC  */
#define VSUROF  246    /*      SUR_OFFS   */
/*
***Multifnster mm. 20/1-95.
*/
#define VGTVIEW 247    /*      GET_VIEW   */
#define VDELMBS 248    /*      DEL_MBS    */
#define VACTCSY 249    /*      ACT_CSY    */
/*
***Nya rutiner fr SAAB 27/2-95.
*/
#define VMODBA  250   /*      MODE_BASIC        */
#define VSURSA  251   /*      SUR_SPLARR        */
#define VSURCA  252   /*      SUR_CONARR        */
#define VSURAP  253   /*      SUR_APPROX        */
#define VSURCO  254   /*      SUR_COMP          */
#define VSURT   255   /*      SUR_TRIM          */
#define VGTTOP  256   /*      GETTOPP           */
#define VGTCUP  257   /*      GETCUBP           */
#define VGTRAP  258   /*      GETRATP           */
#define VCURSA  259   /*      CUR_SPLARR        */
#define VCURCA  260   /*      CUR_CONARR        */
#define VCURFA  261   /*      CUR_FANGA         */
#define VCURGD  262   /*      CUR_GEODESIC      */
#define VCURAP  263   /*      CUR_APPROX        */
#define VRUNMBS 264   /*      RUN_MBS           */
/*
***Nya rutiner fr version 1.14.
*/
#define VAPID   265   /*      ACT_PID           */
#define VAVVERS 266   /*      ACT_VARKON_VERS   */
#define VAVSER  267   /*      ACT_VARKON_SERIAL */
#define VAOSTYP 268   /*      ACT_OSTYPE        */
#define VAHOST  269   /*      ACT_HOST          */
#define VUFNAM  270   /*      UNIQUE_FILENAME   */
#define VRAND   271   /*      RANDOM            */
#define VALLILS 272   /*      ALL_INT_LIN_SUR   */
#define VALLIOS 273   /*      ALL_INV_ON_SUR    */
#define VAPPFIL 274   /*      APPEND_FILE       */
#define VDELFIL 275   /*      DELETE_FILE       */
#define VMOVFIL 276   /*      MOVE_FILE         */
#define VCOPFIL 277   /*      COPY_FILE         */
#define VTSTFIL 278   /*      TEST_FILE         */
#define VGETENV 279   /*      GET_ENVIRONMENT   */
#define VGRID   280   /*      GRID_VIEW         */
#define VGRIDX  281   /*      GRIDX_VIEW        */
#define VGRIDY  282   /*      GRIDY_VIEW        */
#define VGRIDDX 283   /*      GRIDDX_VIEW       */
#define VGRIDDY 284   /*      GRIDDY_VIEW       */
#define VSRTGM  285   /*      SET_ROOT_GM       */
#define VGNXGM  286   /*      GET_NEXT_GM       */
/*
***Nya rutiner fr version 1.15
*/
#define VCRFBUT  287  /*      CRE_FBUTTON       */
#define VCRFICO  288  /*      CRE_FICON         */
#define VGETWIN  289  /*      GET_WIN           */
#define VTXTLW   290  /*      TEXTL_WIN         */
#define VTXTHW   291  /*      TEXTH_WIN         */
#define VLDMDF   292  /*      LOAD_MDF          */
#define VBOX1P   293  /*      BOX_1P            */
#define VBOXEN   294  /*      BOX_ENCLOSE       */
#define VSURROT  295  /*      SUR_ROT           */
#define VCRDBUT  296  /*      CRE_DBUTTON       */
#define VEND     297  /*      ENDP              */
#define VSTART   298  /*      STARTP            */
#define VLDDLL   299  /*      LOAD_DLL          */
#define VCLDLL   300  /*      CALL_DLL_FUNCTION */
#define VULDLL   301  /*      UNLOAD_DLL        */
#define VMTVIEW  302  /*      MATERIAL_VIEW     */
#define VLTVIEW  303  /*      LIGHT_VIEW        */
#define VSHVIEW  304  /*      SHADE_VIEW        */
#define VCRCOL   305  /*      CRE_COLOR         */
#define VLTON    306  /*      LIGHT_ON          */
#define VLTOFF   307  /*      LIGHT_OFF         */
#define VSURUSD  308  /*      SUR_USRDEF        */
#define VSURCYL  309  /*      SUR_CYL           */
#define VCLPM    310  /*      CLEAR_PM          */
#define VSURSWP  311  /*      SUR_SWEEP         */
#define VSURRUL  312  /*      SUR_RULED         */
#define VPOSMBS  313  /*      POS_MBS           */
/*
***Nya rutiner fr version 1.16
*/
#define VGTFAP   314   /*      GETFACP           */
#define VSURNA   315   /*      SUR_NURBSARR      */
#define VSUAREA  316   /*      SURFACE_AREA      */
#define VSEAREA  317   /*      SECTION_AREA      */
#define VGETWDT  318   /*      GETWIDTH          */
#define VACTWDT  319   /*      ACT_WIDTH         */
#define VSCR_2   320   /*      SCREEN_2          */
#define VPOS_2   321   /*      POS_2             */
#define VIDNT_2  322   /*      IDENT_2           */
#define VHIGHL   323   /*      HIGHLIGHT         */
#define VGTPTR   324   /*      GET_POINTER       */
#define VINFNM   325   /*      INFNAME           */
#define VLOADPM  326   /*      LOAD_PM           */
#define VALLILM  327   /*      ALL_INT_LIN_MSUR  */
#define VCALEXT  328   /*      CALL_EXTERN       */
/*
***Nya rutiner fr version 1.17
*/
#define VIVAL     329  /*      IVAL              */
#define VFVAL     330  /*      FVAL              */
#define VODBCCO   331  /*      ODBC_CONNECT      */
#define VODBCED   332  /*      ODBC_EXECDIRECT   */
#define VODBCFE   333  /*      ODBC_FETCH        */
#define VODBCGS   334  /*      ODBC_GETSTRING    */
#define VODBCDC   335  /*      ODBC_DISCONNECT   */
#define VODBCER   336  /*      ODBC_ERROR        */
#define VPUTDAT   337  /*      PUTDAT            */
#define VGETDAT   338  /*      GETDAT            */
#define VDELDAT   339  /*      DELDAT            */
#define VCRAYNPES 340  /*      CRAY_NUM_PES      */
#define VCRAYMYPE 341  /*      CRAY_MY_PE        */
#define VSECGRAV  342  /*      SECTION_CGRAV     */
/*
***Nya rutiner fr LEICA version 1.17
*/
#define VTRACKER   343  /*      TRACKER          */
#define VALIGN     344  /*      ALIGNMENT        */
#define VCLOUD     345  /*      POINT_CLOUD      */
#define VPLANESH   346  /*      PLANAR_SHAPE     */
/*
***New routine for Orebro University version 1.17
*/
#define VSURCURV   347  /*      SUR_CURVES       */
