/**********************************************************************
*
*    eval10.c
*    ========
*
*    This file is part of the VARKON Program Module Library.
*    URL: http://www.varkon.com
*
*    evcrwi();     Evaluerar CRE_WIN
*    evcred();     Evaluerar CRE_EDIT
*    evcrbu();     Evaluerar CRE_BUTTTON
*    evcrdb();     Evaluerar CRE_DBUTTTON
*    evcrfb();     Evaluerar CRE_FBUTTTON
*    evcric();     Evaluerar CRE_ICON
*    evcrfi();     Evaluerar CRE_FICON
*    evgted();     Evaluerar GET_EDIT
*    evgtbu();     Evaluerar GET_BUT
*    evgtwi();     Evaluerar GET_WIN
*    evshwi();     Evaluerar SHOW_WIN
*    evwtwi();     Evaluerar WAIT_WIN
*    evdlwi();     Evaluerar DEL_WIN
*    evgttl();     Evaluerar TEXTL_WIN
*    evgtth();     Evaluerar TEXTH_WIN
*
*    evcaxt();     Evaluerar CALL_EXTERN
*
*    This library is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Library General Public
*    License as published by the Free Software Foundation; either
*    version 2 of the License, or (at your option) any later version.
*
*    This library is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Library General Public License for more details.
*
*    You should have received a copy of the GNU Library General Public
*    License along with this library; if not, write to the Free
*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    (C)Microform AB 1984-1999, Johan Kjellander, johan@microform.se
*
***********************************************************************/

#include "../../DB/include/DB.h"
#include "../../IG/include/IG.h"

#ifdef V3_X11
#include <X11/Xlib.h>
#include "../../WP/include/WP.h"
#endif

#ifdef V3_X11

/*!******************************************************/

        short evcrwi(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar CRE_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      Felkod: PM1052 = Oknd fnstertyp.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   if ( pv[5].par_va.lit.int_va == 0 )
     {
     return(wpwciw((short)pv[1].par_va.lit.vec_va.x_val,
                   (short)pv[1].par_va.lit.vec_va.y_val,
                   (short)pv[2].par_va.lit.float_va,
                   (short)pv[3].par_va.lit.float_va,
                          pv[4].par_va.lit.str_va,
                         &valp->lit.int_va));
     }
   else if ( pv[5].par_va.lit.int_va == 1 )
     {
     return(wpwcgw((short)pv[1].par_va.lit.vec_va.x_val,
                   (short)pv[1].par_va.lit.vec_va.y_val,
                   (short)pv[2].par_va.lit.float_va,
                   (short)pv[3].par_va.lit.float_va,
                          pv[4].par_va.lit.str_va,
                          FALSE,
                         &valp->lit.int_va));
     }
   else return(erpush("PM1052",""));
}

/********************************************************/
/*!******************************************************/

        short evcred(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar CRE_EDIT.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   return(wpmced(       pv[1].par_va.lit.int_va,
                 (short)pv[2].par_va.lit.vec_va.x_val,
                 (short)pv[2].par_va.lit.vec_va.y_val,
                 (short)pv[3].par_va.lit.float_va,
                 (short)pv[4].par_va.lit.float_va,
                 (short)pv[5].par_va.lit.float_va,
                        pv[6].par_va.lit.str_va,
                 (short)pv[7].par_va.lit.int_va,
                       &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrbu(
        PMPARVA  pv[],
        PMLITVA *valp,
        short    npar)

/*      Evaluerar CRE_BUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   char   font[V3STRLEN+1];
   short  cb,cf;

/*
***Nn srskild font ? Parameter nummer 8.
***Om inte skicka tom strng.
*/
   if ( npar > 7 ) strcpy(font,pv[8].par_va.lit.str_va);
   else            font[0] = '\0';
/*
***Bakgrundsfrg ? Parameter nummer 9.
***Om inte skicka 6.
*/
   if ( npar > 8 ) cb = (short)pv[9].par_va.lit.int_va;
   else            cb = WP_BGND;
/*
***Frgrundsfrg ? Parameter nummer 10.
***Om inte skicka 1.
*/
   if ( npar > 9 ) cf = (short)pv[10].par_va.lit.int_va;
   else            cf = WP_FGND;
/*
***Skapa knappen.
*/
   return(wpmcbu(       pv[1].par_va.lit.int_va,
                 (short)pv[2].par_va.lit.vec_va.x_val,
                 (short)pv[2].par_va.lit.vec_va.y_val,
                 (short)pv[3].par_va.lit.float_va,
                 (short)pv[4].par_va.lit.float_va,
                 (short)pv[5].par_va.lit.float_va,
                        pv[6].par_va.lit.str_va,
                        pv[7].par_va.lit.str_va,
                        font,
                        cb,cf,
                       &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrdb(
        PMPARVA  pv[],
        PMLITVA *valp,
        short    npar)

/*      Evaluerar CRE_DBUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-12-09 J. Kjellander
 *
 ******************************************************!*/

{
   char font[V3STRLEN+1];
   int  cb,cf;

/*
***Nn srskild font ? Parameter nummer 8.
***Om inte skicka tom strng.
*/
   if ( npar > 6 ) strcpy(font,pv[7].par_va.lit.str_va);
   else            font[0] = '\0';
/*
***Bakgrundsfrg ? Parameter nummer 8.
***Om inte skicka 6.
*/
   if ( npar > 7 ) cb = pv[8].par_va.lit.int_va;
   else            cb = 6;
/*
***Frgrundsfrg ? Parameter nummer 9.
***Om inte skicka 1.
*/
   if ( npar > 8 ) cf = pv[9].par_va.lit.int_va;
   else            cf = 1;
/*
***Skapa knappen.
*/
   return(wpmcbu(     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                 (int)pv[3].par_va.lit.float_va,
                 (int)pv[4].par_va.lit.float_va,
                 (int)pv[5].par_va.lit.float_va,
                      pv[6].par_va.lit.str_va,
                      pv[6].par_va.lit.str_va,
                      font,
                      cb,cf,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrfb(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar CRE_FBUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-20 J. Kjellander
 *
 ******************************************************!*/

{

/*
***Skapa knappen.
*/
   return(wpcrfb(       pv[1].par_va.lit.int_va,
                 (short)pv[2].par_va.lit.vec_va.x_val,
                 (short)pv[2].par_va.lit.vec_va.y_val,
                 (short)pv[3].par_va.lit.float_va,
                 (short)pv[4].par_va.lit.float_va,
                        pv[5].par_va.lit.str_va,
                        pv[6].par_va.lit.str_va,
                 (short)pv[7].par_va.lit.int_va,
                       &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcric(
        PMPARVA  pv[],
        PMLITVA *valp,
        short    npar)

/*      Evaluerar CRE_ICON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 12/1/94 J. Kjellander
 *
 ******************************************************!*/

{
   short  cb,cf;

/*
***Bakgrundsfrg ? Parameter nummer 5.
***Om inte skicka 6.
*/
   if ( npar > 4 ) cb = (short)pv[5].par_va.lit.int_va;
   else            cb = 6;
/*
***Frgrundsfrg ? Parameter nummer 6.
***Om inte skicka 1.
*/
   if ( npar > 5 ) cf = (short)pv[6].par_va.lit.int_va;
   else            cf = 1;
/*
***Skapa ikonen.
*/
   return(wpmcic(       pv[1].par_va.lit.int_va,
                 (short)pv[2].par_va.lit.vec_va.x_val,
                 (short)pv[2].par_va.lit.vec_va.y_val,
                 (short)pv[3].par_va.lit.float_va,
                        pv[4].par_va.lit.str_va,
                        cb,cf,
                       &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrfi(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar CRE_FICON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-20 J.Kjellander
 *
 ******************************************************!*/

{
/*
***Skapa ikonen.
*/
   return(wpcrfi(       pv[1].par_va.lit.int_va,
                 (short)pv[2].par_va.lit.vec_va.x_val,
                 (short)pv[2].par_va.lit.vec_va.y_val,
                        pv[3].par_va.lit.str_va,
                        pv[4].par_va.lit.str_va,
                 (short)pv[5].par_va.lit.int_va,
                       &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evgted(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar GET_EDIT.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   return(wpgted(pv[1].par_va.lit.int_va,
                 pv[2].par_va.lit.int_va,
                 valp->lit.str_va));
}

/********************************************************/
/*!******************************************************/

        short evgtbu(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar GET_BUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   return(wpgtbu(pv[1].par_va.lit.int_va,
                 pv[2].par_va.lit.int_va,
                &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evgtwi(
        PMPARVA  pv[],
        short    np)

/*      Evaluerar GET_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-21 J. Kjellander
 *
 ******************************************************!*/

{
   short   status;
   int     x,y,dx,dy,typ;
   char    rubrik[V3STRLEN+1];
   PMLITVA litval[5];

   status = wpgtwi(pv[1].par_va.lit.int_va,&x,&y,&dx,&dy,&typ,rubrik);
   if ( status < 0 ) return(status);
/*
***Kopiera parametervrden till PMLITVA.
*/
     litval[0].lit.vec_va.x_val = x;
     litval[0].lit.vec_va.y_val = y;
     litval[0].lit.vec_va.z_val = 0;
     litval[1].lit.int_va       = dx;
     litval[2].lit.int_va       = dy;

     if ( np > 4 ) litval[3].lit.int_va = typ;
     if ( np > 5 ) strcpy(litval[4].lit.str_va,rubrik);
/*
***Skriv parametervrden till motsvarande MBS-variabler.
*/
     return(evwval(litval,np-1,pv));
}

/********************************************************/
/*!******************************************************/

        short evshwi(PMPARVA pv[])

/*      Evaluerar SHOW_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   return(wpwshw(pv[1].par_va.lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evwtwi(
        PMPARVA  pv[],
        PMLITVA *valp)

/*      Evaluerar WAIT_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{
   return(wpwwtw(pv[1].par_va.lit.int_va,
                 SLEVEL_MBS,
                &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evdlwi(
        PMPARVA  pv[],
        short    np)

/*      Evaluerar DEL_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          np   => Antal parametrar
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 6/12/93 J. Kjellander
 *
 ******************************************************!*/

{

/*
***r det ett huvudfnster (npar = 1) eller ett subfnster
***(npar = 2) ?
*/
   if ( np == 1 )
     return(wpwdel(pv[1].par_va.lit.int_va));
   else
     return(wpwdls(pv[1].par_va.lit.int_va,
                   pv[2].par_va.lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evgttl(
        PMPARVA  pv[],
        PMLITVA *valp,
        short    np)

/*      Evaluerar TEXTL_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          np   => Antal parametrar
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-21 J. Kjellander
 *
 ******************************************************!*/

{
   short status;
   int   npix;
   char  fntnam[V3STRLEN+1];

/*
***Om font angetts tar vi den annars skickar vi tom strng.
*/
   if ( np == 1 ) strcpy(fntnam,"");
   else           strcpy(fntnam,pv[2].par_va.lit.str_va);
/*
***Hmta textlngd.
*/
   status = wpgtsl(pv[1].par_va.lit.str_va,fntnam,&npix);
   if ( status < 0 ) return(status);

   valp->lit.int_va = npix;

   return(0);
}

/********************************************************/
/*!******************************************************/

        short evgtth(
        PMPARVA  pv[],
        PMLITVA *valp,
        short    np)

/*      Evaluerar TEXTH_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          np   => Antal parametrar.
 *
 *      Ut: *valp = Fontens hjd.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-21 J. Kjellander
 *
 ******************************************************!*/

{
   short status;
   int   npix;
   char  fntnam[V3STRLEN+1];

/*
***Om font angetts tar vi den annars skickar vi tom strng.
*/
   if ( np == 0 ) strcpy(fntnam,"");
   else           strcpy(fntnam,pv[1].par_va.lit.str_va);
/*
***Hmta textlngd.
*/
   status = wpgtsh(fntnam,&npix);
   if ( status < 0 ) return(status);

   valp->lit.int_va = npix;

   return(0);
}

/********************************************************/

#else
#ifdef WIN32

extern int   mswciw(),msmcbu(),msgtbu(),mswdel(),
             mswshw(),mswwtw(),msmced(),msgted(),
             msmcic(),mswcgw(),mswdls(),mscrfb(),
             mscrfi(),msgtwi(),msgtsl(),msgtsh(),
             mscrdb();
extern short erpush(),evwval();

/*!******************************************************/

        short evcrwi(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar CRE_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      Felkod: PM1052 = Oknd fnstertyp.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   if ( pv[5].par_va.lit.int_va == 0 )
     {
     return(mswciw((int)pv[1].par_va.lit.vec_va.x_val,
                   (int)pv[1].par_va.lit.vec_va.y_val,
                   (int)pv[2].par_va.lit.float_va,
                   (int)pv[3].par_va.lit.float_va,
                   (int)pv[4].par_va.lit.str_va,
                  &valp->lit.int_va));
     }
   else if ( pv[5].par_va.lit.int_va == 1 )
     {
     return(mswcgw((int)pv[1].par_va.lit.vec_va.x_val,
                   (int)pv[1].par_va.lit.vec_va.y_val,
                   (int)pv[2].par_va.lit.float_va,
                   (int)pv[3].par_va.lit.float_va,
                          pv[4].par_va.lit.str_va,
                          FALSE,
                         &valp->lit.int_va));
     }
   else return(erpush("PM1052",""));
}

/********************************************************/
/*!******************************************************/

        short evcred(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar CRE_EDIT.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   return(msmced(     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                 (int)pv[3].par_va.lit.float_va,
                 (int)pv[4].par_va.lit.float_va,
                 (int)pv[5].par_va.lit.float_va,
                      pv[6].par_va.lit.str_va,
                 (int)pv[7].par_va.lit.int_va,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrfb(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar CRE_FBUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-20 J. Kjellander
 *
 ******************************************************!*/

{

/*
***Skapa knappen.
*/
   return(mscrfb(     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                 (int)pv[3].par_va.lit.float_va,
                 (int)pv[4].par_va.lit.float_va,
                      pv[5].par_va.lit.str_va,
                      pv[6].par_va.lit.str_va,
                      pv[7].par_va.lit.int_va,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrbu(pv,valp,npar)
        PMPARVA  pv[];
        PMLITVA *valp;
        short    npar;

/*      Evaluerar CRE_BUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   char font[V3STRLEN+1];
   int  cb,cf;

/*
***Nn srskild font ? Parameter nummer 8.
***Om inte skicka tom strng.
*/
   if ( npar > 7 ) strcpy(font,pv[8].par_va.lit.str_va);
   else            font[0] = '\0';
/*
***Bakgrundsfrg ? Parameter nummer 9.
***Om inte skicka 6.
*/
   if ( npar > 8 ) cb = pv[9].par_va.lit.int_va;
   else            cb = 6;
/*
***Frgrundsfrg ? Parameter nummer 10.
***Om inte skicka 1.
*/
   if ( npar > 9 ) cf = pv[10].par_va.lit.int_va;
   else            cf = 1;
/*
***Skapa knappen.
*/
   return(msmcbu(     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                 (int)pv[3].par_va.lit.float_va,
                 (int)pv[4].par_va.lit.float_va,
                 (int)pv[5].par_va.lit.float_va,
                      pv[6].par_va.lit.str_va,
                      pv[7].par_va.lit.str_va,
                      font,
                      cb,cf,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrdb(pv,valp,npar)
        PMPARVA  pv[];
        PMLITVA *valp;
        short    npar;

/*      Evaluerar CRE_DBUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-12-09 J. Kjellander
 *
 ******************************************************!*/

{
   char font[V3STRLEN+1];
   int  cb,cf;

/*
***Nn srskild font ? Parameter nummer 8.
***Om inte skicka tom strng.
*/
   if ( npar > 6 ) strcpy(font,pv[7].par_va.lit.str_va);
   else            font[0] = '\0';
/*
***Bakgrundsfrg ? Parameter nummer 8.
***Om inte skicka 6.
*/
   if ( npar > 7 ) cb = pv[8].par_va.lit.int_va;
   else            cb = 6;
/*
***Frgrundsfrg ? Parameter nummer 9.
***Om inte skicka 1.
*/
   if ( npar > 8 ) cf = pv[9].par_va.lit.int_va;
   else            cf = 1;
/*
***Skapa knappen.
*/
   return(mscrdb (     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                 (int)pv[3].par_va.lit.float_va,
                 (int)pv[4].par_va.lit.float_va,
                 (int)pv[5].par_va.lit.float_va,
                      pv[6].par_va.lit.str_va,
                      font,
                      cb,cf,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcric(pv,valp,npar)
        PMPARVA  pv[];
        PMLITVA *valp;
        short    npar;

/*      Evaluerar CRE_ICON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   int cb,cf;

/*
***Bakgrundsfrg ? Parameter nummer 5.
***Om inte skicka 6.
*/
   if ( npar > 4 ) cb = pv[5].par_va.lit.int_va;
   else            cb = 6;
/*
***Frgrundsfrg ? Parameter nummer 6.
***Om inte skicka 1.
*/
   if ( npar > 5 ) cf = pv[6].par_va.lit.int_va;
   else            cf = 1;
/*
***Skapa ikonen.
*/
   return(msmcic(     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                 (int)pv[3].par_va.lit.float_va,
                      pv[4].par_va.lit.str_va,
                      cb,cf,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evcrfi(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar CRE_FICON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          npar => Antal parametrar.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-20 J.Kjellander
 *
 ******************************************************!*/

{
/*
***Skapa ikonen.
*/
   return(mscrfi(     pv[1].par_va.lit.int_va,
                 (int)pv[2].par_va.lit.vec_va.x_val,
                 (int)pv[2].par_va.lit.vec_va.y_val,
                      pv[3].par_va.lit.str_va,
                      pv[4].par_va.lit.str_va,
                      pv[5].par_va.lit.int_va,
                     &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evgted(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar GET_EDIT.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   return(msgted(pv[1].par_va.lit.int_va,
                 pv[2].par_va.lit.int_va,
                 valp->lit.str_va));
}

/********************************************************/
/*!******************************************************/

        short evgtbu(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar GET_BUTTON.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   return(msgtbu(pv[1].par_va.lit.int_va,
                 pv[2].par_va.lit.int_va,
                &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evgtwi(pv,np)
        PMPARVA  pv[];
        short    np;

/*      Evaluerar GET_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *
 *      Ut: *valp = Funktionsvrde ifyllt.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-21 J. Kjellander
 *
 ******************************************************!*/

{
   short   status;
   int     x,y,dx,dy,typ;
   char    rubrik[V3STRLEN+1];
   PMLITVA litval[5];

   status = msgtwi(pv[1].par_va.lit.int_va,&x,&y,&dx,&dy,&typ,rubrik);
   if ( status < 0 ) return(status);
/*
***Kopiera parametervrden till PMLITVA.
*/
     litval[0].lit.vec_va.x_val = x;
     litval[0].lit.vec_va.y_val = y;
     litval[0].lit.vec_va.z_val = 0;
     litval[1].lit.int_va       = dx;
     litval[2].lit.int_va       = dy;

     if ( np > 4 ) litval[3].lit.int_va = typ;
     if ( np > 5 ) strcpy(litval[4].lit.str_va,rubrik);
/*
***Skriv parametervrden till motsvarande MBS-variabler.
*/
     return(evwval(litval,np-1,pv));
}

/********************************************************/
/*!******************************************************/

        short evshwi(pv)
        PMPARVA  pv[];

/*      Evaluerar SHOW_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   return(mswshw(pv[1].par_va.lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evwtwi(pv,valp)
        PMPARVA  pv[];
        PMLITVA *valp;

/*      Evaluerar WAIT_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{
   return(mswwtw(pv[1].par_va.lit.int_va,
                 SLEVEL_MBS,
                &valp->lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evdlwi(pv,np)
        PMPARVA  pv[];
        short    np;

/*      Evaluerar DEL_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          np   => Antal parametrar
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 30/11/95 J. Kjellander
 *
 ******************************************************!*/

{

/*
***r det ett huvudfnster (npar = 1) eller ett subfnster
***(npar = 2) ?
*/
   if ( np == 1 )
     return(mswdel(pv[1].par_va.lit.int_va));
   else
     return(mswdls(pv[1].par_va.lit.int_va,
                   pv[2].par_va.lit.int_va));
}

/********************************************************/
/*!******************************************************/

        short evgttl(pv,valp,np)
        PMPARVA  pv[];
        PMLITVA *valp;
        short    np;

/*      Evaluerar TEXTL_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          np   => Antal parametrar
 *
 *      Ut: Inget.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-21 J. Kjellander
 *
 ******************************************************!*/

{
   short status;
   int   npix;
   char  fntnam[V3STRLEN+1];

/*
***Om font angetts tar vi den annars skickar vi tom strng.
*/
   if ( np == 1 ) strcpy(fntnam,"");
   else           strcpy(fntnam,pv[2].par_va.lit.str_va);
/*
***Hmta textlngd.
*/
   status = msgtsl(pv[1].par_va.lit.str_va,fntnam,&npix);
   if ( status < 0 ) return(status);

   valp->lit.int_va = npix;

   return(0);
}

/********************************************************/
/*!******************************************************/

        short evgtth(pv,valp,np)
        PMPARVA  pv[];
        PMLITVA *valp;
        short    np;

/*      Evaluerar TEXTH_WIN.
 *
 *      In: pv   => Pekare till array med parametervrden
 *          valp => Pekare till funktionsvrde.
 *          np   => Antal parametrar.
 *
 *      Ut: *valp = Fontens hjd.
 *
 *      FV: Returnerar anropade rutiners status.
 *
 *      (C)microform ab 1996-05-21 J. Kjellander
 *
 ******************************************************!*/

{
   short status;
   int   npix;
   char  fntnam[V3STRLEN+1];

/*
***Om font angetts tar vi den annars skickar vi tom strng.
*/
   if ( np == 0 ) strcpy(fntnam,"");
   else           strcpy(fntnam,pv[1].par_va.lit.str_va);
/*
***Hmta textlngd.
*/
   status = msgtsh(fntnam,&npix);
   if ( status < 0 ) return(status);

   valp->lit.int_va = npix;

   return(0);
}

/********************************************************/

#else
short evcrwi(){;};
short evcred(){;};
short evcrbu(){;};
short evcric(){;};
short evgted(){;};
short evgtbu(){;};
short evshwi(){;};
short evwtwi(){;};
short evdlwi(){;};
short evcrfb(){;};
short evcrfi(){;};
short evgtwi(){;};
short evgtth(){;};
short evgttl(){;};
#endif
#endif

/********************************************************/
