/**********************************************************************
*
*    eval16.c
*    ========
*
*    This file is part of the VARKON Program Module Library.
*    URL: http://www.varkon.com
*
*    evodco();      Evaluerar ODBC_Connect
*    evoded();      Evaluerar ODBC_Execdirect
*    evodfe();      Evaluerar ODBC_Fetch
*    evodgs();      Evaluerar ODBC_Getstring
*    evoddc();      Evaluerar ODBC_Disconnect
*    evoder();      Evaluerar ODBC_Error
*
*    This library is free software; you can redistribute it and/or
*    modify it under the terms of the GNU Library General Public
*    License as published by the Free Software Foundation; either
*    version 2 of the License, or (at your option) any later version.
*
*    This library is distributed in the hope that it will be useful,
*    but WITHOUT ANY WARRANTY; without even the implied warranty of
*    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*    Library General Public License for more details.
*
*    You should have received a copy of the GNU Library General Public
*    License along with this library; if not, write to the Free
*    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*
*    (C)Microform AB 1984-1999, Johan Kjellander, johan@microform.se
*
***********************************************************************/

#include "../../DB/include/DB.h"
#include "../../IG/include/IG.h"
#include "../../EX/include/EX.h"

/*!******************************************************/

        short evodco(
        PMPARVA  pv[],
        PMLITVA *valp)
 
/*      Interface-rutin fr ODBC_CONNECT.
 *
 *      In:
 *
 *      Ut: Inget.
 *
 *      (C)microform ab 1998-10-12 J. Kjellander
 *
 ******************************************************!*/

  {
   return(EXodco(pv[1].par_va.lit.str_va,
                 pv[2].par_va.lit.str_va,
                 pv[3].par_va.lit.str_va,
                &valp->lit.int_va));
  }

/********************************************************/
/*!******************************************************/

        short evoded(
        PMPARVA  pv[],
        PMLITVA *valp)
 
/*      Interface-rutin fr ODBC_EXECDIRECT.
 *
 *      In:
 *
 *      Ut: Inget.
 *
 *      (C)microform ab 1998-10-12 J. Kjellander
 *
 ******************************************************!*/

  {
   return(EXoded(pv[1].par_va.lit.str_va,
                &valp->lit.int_va));
  }

/********************************************************/
/*!******************************************************/

        short evodfe(PMLITVA *valp)
 
/*      Interface-rutin fr ODBC_FETCH.
 *
 *      In:
 *
 *      Ut: Inget.
 *
 *      (C)microform ab 1998-10-12 J. Kjellander
 *
 ******************************************************!*/

  {
   return(EXodfe(&valp->lit.int_va));
  }

/********************************************************/
/*!******************************************************/

        short evodgs(
        PMPARVA  pv[],
        PMLITVA *valp)
 
/*      Interface-rutin fr ODBC_GETSTRING.
 *
 *      In:
 *
 *      Ut: Inget.
 *
 *      (C)microform ab 1998-10-12 J. Kjellander
 *
 ******************************************************!*/

  {
   short   status;
   PMLITVA litval;

/*
***Hmta vrdet frn ODBC.
*/
   status = EXodgs(litval.lit.str_va,&valp->lit.int_va);
   if ( status < 0 ) return(status);
/*
***Skriv till motsvarande MBS-variabel.
*/
   return(inwvar(pv[1].par_ty,pv[1].par_va.lit.adr_va,0,NULL,&litval));
  }

/********************************************************/
/*!******************************************************/

        short evoddc(PMLITVA *valp)
 
/*      Interface-rutin fr ODBC_DISCONNECT.
 *
 *      In:
 *
 *      Ut: Inget.
 *
 *      (C)microform ab 1998-10-12 J. Kjellander
 *
 ******************************************************!*/

  {
   return(EXoddc(&valp->lit.int_va));
  }

/********************************************************/
/*!******************************************************/

        short evoder(PMLITVA *valp)
 
/*      Interface-rutin fr ODBC_ERROR.
 *
 *      In:
 *
 *      Ut: Inget.
 *
 *      (C)microform ab 1998-10-12 J. Kjellander
 *
 ******************************************************!*/

  {
   return(EXoder(valp->lit.str_va));
  }

/********************************************************/
